regina::NAngleStructure Class Reference
Angle Structures

Represents an angle structure on a triangulation. More...

`#include <angle/nanglestructure.h>`

Inheritance diagram for regina::NAngleStructure:

## Public Member Functions

| NAngleStructure (const NTriangulation *triang, NAngleStructureVector *newVector)
| Creates a new angle structure on the given triangulation with the given coordinate vector. More...
virtual | ~NAngleStructure ()
| Destroys this angle structure. More...
NAngleStructure * | clone () const
| Creates a newly allocated clone of this angle structure. More...
NRational | getAngle (unsigned long tetIndex, int edgePair) const
| Returns the requested angle in this angle structure. More...
const NTriangulation * | getTriangulation () const
| Returns the triangulation on which this angle structure lies. More...
bool | isStrict () const
| Determines whether this is a strict angle structure. More...
bool | isTaut () const
| Determines whether this is a taut angle structure. More...
bool | isVeering () const
| Determines whether this is a veering structure. More...
const NAngleStructureVector * | rawVector () const
| Gives read-only access to the raw vector that sits beneath this angle structure. More...
void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
void | writeXMLData (std::ostream &out) const
| Writes a chunk of XML containing this angle structure and all of its properties. More...
Input and Output
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Protected Member Functions

void | calculateType () const
| Calculates the structure type (strict or taut) and stores it as a property. More...

## Friends

class | regina::NXMLAngleStructureReader

## Detailed Description

Represents an angle structure on a triangulation.

Once the underlying triangulation changes, this angle structure is no longer valid.

## Constructor & Destructor Documentation

regina::NAngleStructure::NAngleStructure | ( | const NTriangulation * | triang,
|  | NAngleStructureVector * | newVector
| ) |  |

inline

Creates a new angle structure on the given triangulation with the given coordinate vector.

Python:
  Not present.

Parameters

  triang | the triangulation on which this angle structure lies.
  newVector | a vector containing the individual angles in the angle structure.

regina::NAngleStructure::~NAngleStructure | ( |  | ) |

inline virtual

Destroys this angle structure.

The underlying vector of angles will also be deallocated.

## Member Function Documentation

void regina::NAngleStructure::calculateType | ( |  | ) | const

protected

Calculates the structure type (strict or taut) and stores it as a property.

NAngleStructure* regina::NAngleStructure::clone | ( |  | ) | const

Creates a newly allocated clone of this angle structure.

Returns
  a clone of this angle structure.

std::string regina::ShareableObject::detail | ( |  | ) | const

inherited

Returns the output from writeTextLong() as a string.

Returns
  a long text representation of this object.

NRational regina::NAngleStructure::getAngle | ( | unsigned long | tetIndex,
|  | int | edgePair
| ) |  | const

Returns the requested angle in this angle structure.

The angle returned will be scaled down; the actual angle is the returned value multiplied by pi.

Parameters

  tetIndex | the index in the triangulation of the tetrahedron in which the requested angle lives; this should be between 0 and NTriangulation::getNumberOfTetrahedra()-1 inclusive.
  edgePair | the number of the vertex splitting representing the pair of edges holding the requested angle; this should be between 0 and 2 inclusive. See regina::vertexSplit and regina::vertexSplitDefn for details regarding vertex splittings.

Returns
  the requested angle scaled down by pi.

const NTriangulation * regina::NAngleStructure::getTriangulation | ( |  | ) | const

inline

Returns the triangulation on which this angle structure lies.

Returns
  the underlying triangulation.

bool regina::NAngleStructure::isStrict | ( |  | ) | const

inline

Determines whether this is a strict angle structure.

A strict angle structure has all angles strictly between (not including) 0 and pi.

Returns
  `true` if and only if this is a strict angle structure.

bool regina::NAngleStructure::isTaut | ( |  | ) | const

inline

Determines whether this is a taut angle structure.

A taut angle structure contains only angles 0 and pi.

Here we use the Kang-Rubinstein definition of a taut angle structure [1], which is based on the angles alone. In his original paper [2], Lackenby has an extra condition whereby 2-faces of the triangulation must have consistent coorientations, which we do not enforce here.

[1] E. Kang and J. H. Rubinstein, "Ideal triangulations of 3-manifolds II; Taut and angle structures", Algebr. Geom. Topol. 5 (2005), pp. 1505-1533.

[2] M. Lackenby, "Taut ideal triangulations of 3-manifolds", Geom. Topol. 4 (2000), pp. 369-395.

Returns
  `true` if and only if this is a taut structure.

bool regina::NAngleStructure::isVeering | ( |  | ) | const

inline

Determines whether this is a veering structure.

A veering structure is taut angle structure with additional strong combinatorial constraints, which we do not outline here. For a definition, see C. D. Hodgson, J. H. Rubinstein, H. Segerman, and S. Tillmann, "Veering triangulations admit strict angle structures", Geom. Topol., 15 (2011), pp. 2073-2089.

Note that the Hodgson et al. definition is slightly more general than Agol's veering taut triangulations from his original paper: I. Agol, " Ideal triangulations of pseudo-Anosov mapping tori", in "Topology and Geometry in Dimension Three", volume 560 of Contemp. Math., pp. 1-17, Amer. Math. Soc., 2011. This mirrors the way in which the Kang-Rubinstein definition of taut angle structure is slightly more general than Lackenby's. See the Hodgson et al. paper for full details and comparisons between the two settings.

If this angle structure is not taut, or if the underlying triangulation is non-orientable, then this routine will return `false`.

Returns
  `true` if and only if this is a veering structure.

const NAngleStructureVector * regina::NAngleStructure::rawVector | ( |  | ) | const

inline

Gives read-only access to the raw vector that sits beneath this angle structure.

Generally users should not need this function. However, it is provided here in case the need should arise (e.g., for reasons of efficiency).

Python:
  Not present.

Returns
  the underlying raw vector.

std::string regina::ShareableObject::str | ( |  | ) | const

inherited

Returns the output from writeTextShort() as a string.

Python:
  This implements the `__str__()` function.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toString | ( |  | ) | const

inline inherited

A deprecated alias for str(), which returns the output from writeTextShort() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type str() instead.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toStringLong | ( |  | ) | const

inline inherited

A deprecated alias for detail(), which returns the output from writeTextLong() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type detail() instead.

Returns
  a long text representation of this object.

void regina::ShareableObject::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented in regina::NSnapPeaTriangulation, regina::NGroupPresentation, regina::NHomMarkedAbelianGroup, regina::NNormalSurfaceList, regina::NTetrahedron, regina::NSatRegion, regina::NVertex, regina::NEdge, regina::Dim2Triangle, regina::NTriangle, regina::NLayeredSolidTorus, regina::NHomGroupPresentation, regina::NGenericIsomorphism< dim >, regina::NGenericIsomorphism< 2 >, regina::NGenericIsomorphism< 3 >, regina::NTriangulation, regina::NComponent, regina::NTxICore, regina::NTriSolidTorus, regina::NAngleStructureList, regina::Dim2Edge, regina::NBoundaryComponent, regina::NLayeredChain, regina::Dim2Vertex, regina::Dim2Component, regina::NScript, regina::NAugTriSolidTorus, regina::NSpiralSolidTorus, regina::NSurfaceFilterProperties, regina::NLayeredTorusBundle, regina::NManifold, regina::NPlugTriSolidTorus, regina::NMatrixInt, regina::NBlockedSFSTriple, regina::NPluggedTorusBundle, regina::Dim2Triangulation, regina::NSurfaceSubset, regina::NLayeredLensSpace, regina::NLayeredLoop, regina::NFileInfo, regina::NBlockedSFSLoop, regina::NSnappedBall, regina::NBlockedSFSPair, regina::Dim2BoundaryComponent, regina::NTrivialTri, regina::NL31Pillow, regina::NLayeredChainPair, regina::NText, regina::NSurfaceFilterCombination, and regina::NBlockedSFS.

void regina::NAngleStructure::writeTextShort | ( | std::ostream & | out | ) | const

virtual

Writes this object in short text format to the given output stream.

The output should be human-readable, should fit on a single line, and should not end with a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Implements regina::ShareableObject.

void regina::NAngleStructure::writeXMLData | ( | std::ostream & | out | ) | const

Writes a chunk of XML containing this angle structure and all of its properties.

This routine will be called from within NAngleStructureList::writeXMLPacketData().

Python:
  Not present.

Parameters

  out | the output stream to which the XML should be written.

The documentation for this class was generated from the following file:

- angle/nanglestructure.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).